diff --git a/gnu/packages/dart.scm b/gnu/packages/dart.scm
index 9fcd483168..1ebea4979e 100644
--- a/gnu/packages/dart.scm
+++ b/gnu/packages/dart.scm
@@ -620,3 +620,96 @@
     (native-inputs
      (alist-replace "dart" `(,dart-2.0.0-dev.20.0)
                     (package-native-inputs dart-2.0.0-dev.20.0)))))
+
+(define-public dart-2.0.0-dev.54.0
+  (package
+    (inherit dart-2.0.0-dev.36.0)
+    ;; This version adds FileMode, required to build 2.0
+    (version "2.0.0-dev.54.0")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/dart-lang/sdk")
+             (commit version)))
+       (sha256
+        (base32
+         "05m64i6wa9nk3x3dby5yp06aqyl2pd7sk8sm1wiaijbish1q5drc"))))
+    (arguments
+     (substitute-keyword-arguments (package-arguments dart-2.0.0-dev.36.0)
+       ((#:phases phases)
+        `(modify-phases ,phases
+           (replace 'set-dart-path
+             (lambda* (#:key inputs propagated-inputs #:allow-other-keys)
+               (substitute* "tools/utils.py"
+                 (("os.path.join\\(CheckedInSdkPath\\(\\), 'bin', name)")
+                  (string-append "os.path.join(\""
+                                 (assoc-ref %build-inputs "dart")
+                                 "/bin/\", name)")))))))))
+    (inputs
+     (replace-inputs
+      dart-2.0.0-dev.36.0
+      `(("dart-pkg-args"
+         ,(dart-pkg "args" "1.4.1"
+                    "0ylasxd8v0q80pz0h518yxhbdklabbly1g4n81v8w19vlk2nd8aj"))
+        ("dart-pkg-async"
+         ,(dart-pkg "async" "2.0.6"
+                    "1zibp9hiys9f0y3lpxhbbpg2q824jc7x5gcqdicxpylv7smmcdd5"))
+        ("dart-pkg-barback"
+         ,(dart-pkg "barback" "0.15.2+14"
+                    "17v6l3z3dm4indr1z787mcdgirsz0y34yccsnfs8yf0yb9mbhqk4"))
+        ("dart-pkg-collection"
+         ,(dart-pkg "collection" "1.14.6"
+                    "1majrhazk0ccrrnhxa1pji803r5yywv0a2bmhp5n6sk0a89ps7v7"))
+        ("dart-pkg-dart2js-info"
+         ,(dart-pkg "dart2js-info" "0.5.6+2"
+                    "1k5kylr1805gdsbkvwv8fsh0vv5znikgrd2p2m7mvywlzaaaw5v3"))
+        ("dart-pkg-dartdoc"
+         ,(dart-pkg "dartdoc" "v0.19.0"
+                    "0x95pwvw1b5dwix65rizz15ri2kblw7z6jnq3qb0b9s82b46l7sm"))
+        ("dart-pkg-html"
+         ,(dart-pkg "html" "0.13.3"
+                    "1d78m0f6jvcam4w47733w94ln01rwq9bbk6l219mg6ppczdsps4n"))
+        ("dart-pkg-http"
+         ,(dart-pkg "http" "0.11.3+16"
+                    "1r0gikhy1g2viiic2yfav5xf8xwp21z06blvwmdf4h9fvmj00ac2"))
+        ("dart-pkg-http-retry"
+         ,(dart-pkg "http-retry" "0.1.1"
+                    "1pi6f3jm6kzch8nzdjbwzzyc5spiwl2609c6h7kb2zj6cxyjsm9h"))
+        ("dart-pkg-linter"
+         ,(dart-pkg "linter" "0.1.46"
+                    "03298xfpb1blxh4js2ia73dl077aivfjffdqmy47nilkijwva4cs"))
+        ("dart-pkg-markdown"
+         ,(dart-pkg "markdown" "1.1.1"
+                    "1qj7dmwz6dwq7jsvzxa2qw2fcf68m5yhr8xs8mm65c6rlsxz6vm5"))
+        ("dart-pkg-protobuf"
+         ,(dart-pkg "protobuf" "0.7.1"
+                    "0fwq06ls5x9q8z2xydd0a00lj8mnkn0zdc365qsdnzj8dkgm3006"))
+        ("dart-pkg-pub"
+         ,(dart-pkg "pub" "875d35005a7d33f367d70a3e31e9d3bad5d1ebd8"
+                    "1hb0c9fnyjzd0bz2rmn9ja7ybbwnvyvkmaqh7y1mhg4vk4pzcbmm"))
+        ("dart-pkg-quiver"
+         ,(dart-pkg "quiver" "5aaa3f58c48608af5b027444d561270b53f15dbf"
+                    "0mv97c2f0z0bb1917bjlb903fjjw794pdbv4vk7kcfg1wzp907vl"
+                    "https://github.com/google/quiver-dart"))
+        ("dart-pkg-scheduled-test"
+         ,(dart-pkg "scheduled-test" "0.12.11"
+                    "1r631dvq3pwr10kc1wmqvlhx5lc0hx5h2ix9sp462w6yv03ry7rq"))
+        ("dart-pkg-shelf"
+         ,(dart-pkg "shelf" "0.7.2"
+                    "1z88dwjlwf88ckg0wi4b9kcn44c4y4mnkdppxv0g1hg6b07jsd3x"))
+        ("dart-pkg-stack-trace"
+         ,(dart-pkg "stack-trace" "1.9.2"
+                    "1a2mmjs4c7p6g3pr346hqhfx25d4h1i5vb2np03ydh7pkp19lgmw"))
+        ("dart-pkg-stream-channel"
+         ,(dart-pkg "stream-channel" "1.6.4"
+                    "1qj9n0pk7n1zlkdffy70cllqpxkvfqxswr70nw7ycygxm9bsnbwq"))
+        ("dart-pkg-test-reflective-loader"
+         ,(dart-pkg "test-reflective-loader" "0.1.4"
+                    "1rkgpsnl9izfy97dbsc4y53kmiin6pyhj5652bw8sl0z2n6za1pp"))
+        ("dart-pkg-yaml"
+         ,(dart-pkg "yaml" "2.1.13"
+                    "16xnx7xgm8vsf22dzg6p7zyjax5jad5x4ibky3gqkqh7wavfxhwg")))))
+    (native-inputs
+     (alist-replace "dart" `(,dart-2.0.0-dev.36.0)
+                    (package-native-inputs dart-2.0.0-dev.36.0)))))