diff --git a/gnu/packages/ebook.scm b/gnu/packages/ebook.scm
index a23c677880..a98fea707b 100644
--- a/gnu/packages/ebook.scm
+++ b/gnu/packages/ebook.scm
@@ -149,7 +149,7 @@ (define-public calibre
        ("python2-css-parser" ,python2-css-parser)
        ("python2-dateutil" ,python2-dateutil)
        ("python2-dbus" ,python2-dbus)
-       ("python2-dnspython" ,python2-dnspython)
+       ("python2-dnspython" ,python2-dnspython-1.16)
        ("python2-dukpy" ,python2-dukpy)
        ("python2-feedparser" ,python2-feedparser)
        ("python2-html2text" ,python2-html2text)
diff --git a/gnu/packages/finance.scm b/gnu/packages/finance.scm
index b19d28c123..1f97077fc6 100644
--- a/gnu/packages/finance.scm
+++ b/gnu/packages/finance.scm
@@ -524,7 +524,7 @@ (define-public electrum
        ("python-aiohttp-socks" ,python-aiohttp-socks)
        ("python-aiorpcx" ,python-aiorpcx)
        ("python-certifi" ,python-certifi)
-       ("python-dnspython" ,python-dnspython)
+       ("python-dnspython" ,python-dnspython-1.16)
        ("python-jsonrpclib-pelix" ,python-jsonrpclib-pelix)))
     (arguments
      `(#:tests? #f                      ; no tests
diff --git a/gnu/packages/python-xyz.scm b/gnu/packages/python-xyz.scm
index c20e32fd79..10b271de21 100644
--- a/gnu/packages/python-xyz.scm
+++ b/gnu/packages/python-xyz.scm
@@ -15,7 +15,7 @@
 ;;; Copyright © 2015, 2017 Ben Woodcroft <donttrustben@gmail.com>
 ;;; Copyright © 2015, 2016 Erik Edrosa <erik.edrosa@gmail.com>
 ;;; Copyright © 2015, 2016, 2017, 2018, 2019, 2020 Efraim Flashner <efraim@flashner.co.il>
-;;; Copyright © 2015, 2017 Kyle Meyer <kyle@kyleam.com>
+;;; Copyright © 2015, 2017, 2020 Kyle Meyer <kyle@kyleam.com>
 ;;; Copyright © 2015, 2016 Chris Marusich <cmmarusich@gmail.com>
 ;;; Copyright © 2016 Danny Milosavljevic <dannym+a@scratchpost.org>
 ;;; Copyright © 2016 Lukas Gradl <lgradl@openmailbox.org>
@@ -13381,17 +13381,17 @@ (define-public python2-lazy-object-proxy
 (define-public python-dnspython
   (package
     (name "python-dnspython")
-    (version "1.16.0")
+    (version "2.0.0")
     (source (origin
               (method url-fetch)
-              (uri (string-append "http://www.dnspython.org/kits/"
-                                  version "/dnspython-" version ".tar.gz"))
+              (uri (pypi-uri "dnspython" version ".zip"))
               (sha256
                (base32
-                "1yaw7irazy42n0kdhlk7wyg8ki34rxcnc5xbc1wfwy245b0wbxab"))))
+                "1dyip5ygqqhrgcaiy7qzjpndl9xciip186paxqwkm726fj9z0jh4"))))
     (build-system python-build-system)
+    (native-inputs `(("unzip" ,unzip)))
     (arguments '(#:tests? #f))          ; XXX: requires internet access
-    (home-page "http://www.dnspython.org")
+    (home-page "https://www.dnspython.org")
     (synopsis "DNS toolkit for Python")
     (description
      "dnspython is a DNS toolkit for Python.  It supports almost all record
@@ -13399,8 +13399,21 @@ (define-public python-dnspython
 It supports TSIG authenticated messages and EDNS0.")
     (license license:expat)))
 
-(define-public python2-dnspython
-  (package-with-python2 python-dnspython))
+(define-public python-dnspython-1.16
+  (package
+    (inherit python-dnspython)
+    (version "1.16.0")
+    (source (origin
+              (method url-fetch)
+              (uri (string-append "http://www.dnspython.org/kits/"
+                                  version "/dnspython-" version ".tar.gz"))
+              (sha256
+               (base32
+                "1yaw7irazy42n0kdhlk7wyg8ki34rxcnc5xbc1wfwy245b0wbxab"))))
+    (native-inputs '())))
+
+(define-public python2-dnspython-1.16
+  (package-with-python2 python-dnspython-1.16))
 
 (define-public python-py3dns
   (package
diff --git a/gnu/packages/web.scm b/gnu/packages/web.scm
index 794e2c919d..4480ab9eb7 100644
--- a/gnu/packages/web.scm
+++ b/gnu/packages/web.scm
@@ -6418,7 +6418,7 @@ (define-public linkchecker
          "03ihjmc4bqxxqv71bb43r2f23sx0xnbq1k2fsg9fw05qa5s9x187"))))
     (build-system python-build-system)
     (inputs
-     `(("python2-dnspython" ,python2-dnspython)
+     `(("python2-dnspython" ,python2-dnspython-1.16)
        ("python2-pyxdg" ,python2-pyxdg)
        ("python2-requests" ,python2-requests)))
     (native-inputs